SystemOrganization addCategory: 'OrbeonBPMWebBasic'!

SEWAFWebObjectComposite subclass: #WABasicBpmChartComposite
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WABasicBpmChartComposite methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas
	^canvas! !

!WABasicBpmChartComposite methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas: newValue
	canvas := newValue! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 07:34'!
getAllArray

	^Array with: ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 08:02'!
getApplicationName

	^self searchValueAt: 'application' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:37'!
getBpmUserName

	^self searchValueAt: 'bpm-user' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/11/2016 02:55'!
getDateFromSearchValueNamed: aString onError: anObject

	^[Date fromString: (self searchValueAt: aString)] on: Error do: [:err| anObject]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getEndDate

	^self getDateFromSearchValueNamed: 'end' onError: (Date fromString: '12/31/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName

	^(self searchValueAt: 'field-name' ifAbsent: [^nil]), '[s]'  "FIX THIS - FIELD NAMES INCLUDES THE TYPE"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName2

	^(self searchValueAt: 'field-name-2' ifAbsent: [^nil])! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFormName

	^self searchValueAt: 'form-name' ifAbsent: [^nil]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getProcessFieldList
	| fields selectedFormName |

	fields := OrderedCollection new.
	selectedFormName := self getFormName.

	self getSelectedProcessDefinitions do: [:procDef | 
		(procDef getTasks select: [:each | each name = selectedFormName]) do: [:eachTask | fields addAll: eachTask getComponentClass getFieldsNames]].

	^fields asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getProcessFormsList
	| forms |

	forms := OrderedCollection new.

	self getSelectedProcessDefinitions do: [:procDef | forms addAll: procDef  getOrderedTasksNames].

	^forms asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:46'!
getProcessName

	^self searchValueAt: 'process-name' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 09:08'!
getRoleName

	^self searchValueAt: 'role' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getSelectedProcessDefinitions
	| versions |

	versions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	self isAllVersionSelected ifTrue: [^versions].

	^versions select: [:each | each version printString = self getVersion]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getStartDate

	^self getDateFromSearchValueNamed: 'start' onError: (Date fromString: '01/01/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getVersion

	^(self searchValueAt: 'version' ifAbsent: [^nil]) ifNotNil: [:value | (value = 'All') ifTrue: [nil] ifFalse: [value]]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:42'!
initialize

	super initialize.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/08/2016 07:37'!
isAllRolesSelected

	^(self searchValueAt: 'role' ifAbsent: [false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/08/2016 07:37'!
isAllVersionSelected

	^(self searchValueAt: 'version' ifAbsent: [false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/09/2016 08:02'!
isAverageTaskTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Average Time per Task'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/05/2016 13:27'!
isBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Bar Chart'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/03/2016 04:54'!
isCreationDayDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Creation Day'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/05/2016 13:27'!
isDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Donut Chart'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/06/2016 07:21'!
isDoubleBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Double Bar Chart'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/06/2016 07:56'!
isDoubleChart

	^self isDoubleBarChart or: [self isDoubleDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/06/2016 07:21'!
isDoubleDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Double Donut Chart'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/04/2016 10:20'!
isFieldValueDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Field Value'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/08/2016 08:16'!
isNumberOfTasksDistributionSelection

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Number of Tasks'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 06:39'!
isNumberOfUsersDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Users' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/01/2016 07:47'!
isProcessDefinitionDistributionAndBarChart

	^((self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Process Definition') 
		and:[(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Bar Chart']! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/01/2016 07:47'!
isProcessDefinitionDistributionAndDonutChart

	^((self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Process Definition') 
		and:[(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Donut Chart']! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/07/2016 03:18'!
isProcessesAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Processes Average Time'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/04/2016 09:34'!
isProcessInstanceDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Process Instances'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/04/2016 09:34'!
isProcessInstanceDistributionAndBarChart

	^self isProcessInstanceDistribution
		and:[(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Bar Chart']! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/04/2016 09:34'!
isProcessInstanceDistributionAndDonutChart

	^self isProcessInstanceDistribution
		and:[(self searchValueAt: 'chart-type' ifAbsent: [nil]) = 'Donut Chart']! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/07/2016 03:18'!
isTasksAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Tasks Average Time'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/08/2016 14:27'!
isUnassignedTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Unassigned Tasks'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/09/2016 08:00'!
isUserNumberOfTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Number of Tasks'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/09/2016 07:59'!
isUserPossibleTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = 'Possible Tasks'! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:51'!
queryBlock

	^(self searchValueAt: 'process-condition') 
		ifNil: [[:each | true]] 
		ifNotNil: [:blockString | blockString evaluate]! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/04/2016 04:44'!
renderActiveDistributionComboOn: html withDistribution: distributionNames

	^self renderGenericActiveComboOn: html withList: distributionNames forVariable: 'distribution' label: 'Distribution'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:36'!
renderApplicationComboOn: html

	self renderApplicationComboOn: html withApplications: (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection.! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 08:09'!
renderApplicationComboOn: html withApplications: applicationNames

	^self renderGenericActiveComboOn: html withList: (#(''), applicationNames) forVariable: 'application' label: 'Application'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/04/2016 04:55'!
renderChartTypeComboOn: html withCharts: chartsNames
	| chartTypes |

	chartTypes := chartsNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: chartTypes forVariable: 'chart-type' label: 'Chart Type'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:19'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAreaOn: html].

	canvas notNil ifTrue: [self renderGraphOn: html]! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/04/2016 04:57'!
renderDistributionComboOn: html withDistribution: distributionNames
	| distributionTypes |

	distributionTypes := distributionNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: distributionTypes forVariable: 'distribution' label: 'Distribution'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 08:08'!
renderGenericActiveComboOn: html withList: comboList forVariable: varName label: label
	| combo |

	html div class: 'top-search-div'; with: [

		html label attributeAt: 'for' put: varName; with: (label translateFor: self session user).

		combo := html select
						attributeAt: 'id' put: varName; 
						class: 'width-200px';
						list: comboList;
						onChange: 'submit()';
						selected: (searchValues at: varName ifAbsent: ['']);
						callback: [:value | searchValues at: varName put: value].
	].

	^combo! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 07:45'!
renderGenericComboOn: html withList: comboList forVariable: varName label: label
	| combo |

	html div class: 'top-search-div'; with: [

		html label attributeAt: 'for' put: varName; with: (label translateFor: self session user).

		combo := html select
						attributeAt: 'id' put: varName; 
						class: 'width-200px';
						list: comboList;
						selected: (searchValues at: varName ifAbsent: ['']);
						callback: [:value | searchValues at: varName put: value].
	].

	^combo! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 05:01'!
renderGraphOn: html

	html div id: 'orbeon-graph'; class: 'overflow-scroll height100per width-100per'; with: [html html: canvas contents].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/10/2016 03:14'!
renderQueryConditionOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'process-condition'; with: ('Condition Block' translateFor: self session user).

		html textArea 
			class: 'process-query-condition';
			attributeAt: 'id' put: 'process-condition'; 
			callback: [:value | self addSearchValue: value named: 'process-condition']; 
			with: (self searchValueAt: 'process-condition').
	].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:47'!
renderRolesComboOn: html 
 
	^self renderRolesComboOn: html withRoles: ((BpmFrontOfficeRole getRolsInAppName: self getApplicationName) collect: [:each | each name]) asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:38'!
renderRolesComboOn: html withRoles: roleNames

	^self renderGenericActiveComboOn: html withList: (self getAllArray, roleNames) forVariable: 'role' label: 'Role'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:17'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 05:25'!
renderShowChartButtonOn: html

	html div id: 'top-search-filters-one'; with: [
		html submitButton 
			style: 'margin-top: 25px;';
			callback: [self showChart]; 
			with: ('Show Chart' translateFor: self session user)
	]! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/05/2016 11:51'!
renderStartEndDatesOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'start'; with: ('Start' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'start'; 
				callback: [:value | self addSearchValue: value named: 'start']; 
				with: (self searchValueAt: 'start').
	].

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'end'; with: ('End' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'end'; 
				callback: [:value | self addSearchValue: value named: 'end']; 
				with: (self searchValueAt: 'end').
	].! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 07:59'!
showChart

	^self subclassResponsibility! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 10/31/2016 10:29'!
svgCanvasClass

	^JASVGIGraphCanvas! !
